\name{IMA-package}
\alias{IMA-package}
\alias{IMA}
\docType{package}
\title{
IMA(Illumina Methylation Analyzer) is a package designed to automate the pipeline for exploratory analysis and summarization of site-level and region-level methylation changes in epigenetic studies utilizing the 450K DNA methylation microarray
}
\description{
IMA automates the tasks commonly required for the exploratory analysis and summarization of epigenetic data sets utilizing the 450K DNA methylation microarray. The package makes use of Illumina methylation annotation for region definition, as well as several Bioconductor packages for various preprocessing and differential testing steps. There are two major differences between IMA and existing packages for Infinium methylation microarray analysis. First, instead of analyzing CpG site only, IMA provide both site-level and region-level methylation analysis. Second, instead of manually calling individual R functions at the command line, IMA provides a pipeline which automate the tasks commonly required for the exploratory analysis and summarization of 450K microarray data. The user can either run the pipeline with default setting or specify optional routes in the parameter file of pipeline.

The main purpose of developing IMA package is to provide a range of commonly used analysis options for potential users to perform exploratory analysis and summarization of 450K microarray data in an automatic way. It is the best interest for the users to consult experienced bioinformatician/statistician about which specific analysis option should be chosen for their 450k microarray data. Written in open source R environment, it provides the flexibility for users to adopt, extend and customize the functionality for their specific needs. It can be used as an automatic pipeline to analyze specific regions as well as specific sites for downstream functional exploration and hypothesis generation.
}
\details{
\tabular{ll}{
Package: \tab IMA\cr
Type: \tab Package\cr
Version: \tab 2.0\cr
Date: \tab 2011-11-17\cr
License: \tab GPL\cr
Lazyload: \tab yes\cr
}

}
\author{
Dan Wang, Li Yang, Qiang Hu,Dominic J Smiraglia,Song Liu
  
Maintainer: Dan Wang <wangdan412@gmail.com>
}
\seealso{
  \code{\link{IMA.methy450R}},\code{\link{IMA.methy450PP}},\code{\link{regionswrapper}},\code{\link{testfunc}},\code{\link{sitetest}},\code{\link{indexregionfunc}},\code{\link{annotfunc}}
}
\examples{
###Users specify the data paths/paramters in the pipeline.R before
#run the comman below 
###R --no-save < pipeline.R##This will automately produce the result
#of methylation change
###the pipeline.R file could be found here
###http://ima.r-forge.r-project.org/
}

