\name{indexregionfunc}
\alias{indexregionfunc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Region-level Methylation Index Calculation
}
\description{
  For each specific region of a gene, IMA will collect the loci within it and derive an index of overall region methylation value. Currently, there are three different index metrics implemented in IMA: mean, median, and Tukey's Biweight robust average.  By default, the mean \emph{beta} values will be used as the region's methylation index for further analysis.
}
\usage{
indexregionfunc(indexlist, beta, indexmethod = c("mean", "median", "tbrm"))
}
\arguments{
  \item{indexlist}{specify the region(s) of interest
}
\item{beta}{
  \eqn{\beta} value matrix for the 450K microarray
}
\item{indexmethod}{
  The methods available to derive an index of overall region methylation value for each region. The options are mean, median, and Tukey's Biweight robust average.
}
}
\value{
  return a matrix of the index of overall methylation value for the region(s) of interest
}
\author{
  Dan Wang; Li Yan; Qiang Hu;Dominic J Smiraglia; Song Liu

  Maintainer: Dan Wang <wangdan412@gmail.com>
}

\examples{
# >beta = dataf@bmatrix;##dataf is returned by IMA.methy450PP() function
# >betar =indexregionfunc(indexlist=dataf@TSS1500Ind,beta=beta,indexmethod="mean")
}
