\name{outputDMfunc}
\alias{outputDMfunc}
\title{
Output the differentially methylated sites/regions
}
\description{
  This function will output the differential testing results with user-specified significance criteria.
 }
\usage{
outputDMfunc(out, rawpcut = 0.05, adjustpcut = 0.05, betadiffcut = 0.14)
}
\arguments{
  \item{out}{
This is the output by function of \emph{sitetest}, \emph{testfunc} or \emph{regionwrapper} with three columns for each site/region: p-value, adjusted p-value and
\eqn{\beta} value difference.
}
  \item{rawpcut}{
either null or define the output cut-off for the raw p-value
}
\item{adjustpcut}{
either null or define the output cut-off for the adjusted p-value

}
  \item{betadiffcut}{
either null or define the output cut-off for the \eqn{\beta} value difference between two groups.
}

}

\value{
return a matrix with "P-Value", "Adjust Pval","beta-Difference" in separate columns for each site/region satisfying the specified significance criteria.
}
\author{
Dan Wang, Li Yan, Qiang Hu, Dominic J Smiraglia, Song Liu

Maintainer: Dan Wang <wangdan412@gmail.com>
}
\seealso{
  \code{\link{IMA.methy450R}},\code{\link{regionswrapper}},\code{\link{IMA.methy450PP}},\code{\link{testfunc}},\code{\link{indexregionfunc}}
}
\examples{
# > sitetest = sitetest(dataf,gcase="g2",gcontrol="g1",testmethod = "mean",
# + Padj="BH",rawpcut = NULL,adjustpcut =NULL,betadiffcut = NULL)
# > sitetest = outputDMfunc(sitetest,rawpcut = 0.05,adjustpcut =0.05,
# + betadiffcut = 0.14)
### The list of loci with adjusted p-value less than 0.05 and beta value 
### difference at least 0.14 will be outputted
}
