\name{testfunc}
\alias{testfunc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Differential methylation testing function
}
\description{
  Choose the testing function for differential methylation inference
}

\usage{
testfunc(eset, concov = c("ON", "OFF"), testmethod = c("wilcox","limma", "pooled",
"satterthwaite", "paired"), Padj = c("holm", "hochberg", "hommel","bonferroni", 
"BH", "BY","fdr", "none"), groupinfo, gcase = "g1", gcontrol = "g2", paired = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{eset}{
a \eqn{beta} value matrix
}
\item{concov}{
 if "ON", covariates is continuous variable, and "grouplev" should be the continuous values.
}
  \item{testmethod}{
Wilcoxon rank-sum test (default), Student's t-test ("pooled" or "satterthwaite"), or empirical Bayes statistics.
}
  \item{Padj}{
The methods available for multiple testing correction. Users could choose any method provided in the \emph{p.adjust} function of R \emph{stat} package.
}
\item{groupinfo}{
phenotype information for each sample
}
\item{gcase}{
the string names of case group/groups in the sample.txt file
}
\item{gcontrol}{
the string names of control group/groups in the sample.txt file
}
 \item{paired}{
if TRUE, the test method would change to the corresponding paired-test method
   %%     ~~Describe \code{paired} here~~
}
}
\value{
return a matrix with "P-Value", "Adjust Pval","beta-Difference" in separate columns for each site or annotated region
}
\author{
Dan Wang, Li Yan, Qiang Hu, Dominic J Smiraglia, Song Liu

Maintainer: Dan Wang <wangdan412@gmail.com>
}
\seealso{
  \code{\link{IMA.methy450R}},\code{\link{regionswrapper}},\code{\link{IMA.methy450PP}},\code{\link{sitetest}},\code{\link{indexregionfunc}}
}
\examples{
# > beta = dataf@bmatrix;##dataf returned by IMA.methy450PP()
# > betar= indexregionfunc(indexlist=dataf@TSS1500Ind,beta=beta,indexmethod="mean")
# > TSS1500testALL = testfunc(eset =betar,testmethod="limma",Padj="BH",concov="OFF",
# + groupinfo = dataf2@groupinfo,gcase ="g1",gcontrol="g2",paired = TRUE)

}
